<?php

/**
 * Problem:
 *
 * Each new term in the Fibonacci sequence is generated by adding the previous
 * two terms. By starting with 1 and 2, the first 10 terms will be:
 *
 * 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, ...
 *
 * By considering the terms in the Fibonacci sequence whose values do not
 * exceed four million, find the sum of the even-valued terms.
 *
 *
 * Answer:
 *
 * 4613732
 *
 *
 * @link https://projecteuler.net/problem=2
 */

/**
 * @return int
 */
function problem2(): int
{
    $maxNumber = 4000000;
    $currNumber = 1;
    $nextNumber = 2;
    $answer = 0;

    while ($currNumber <= $maxNumber) {
        $answer += $currNumber % 2 == 0 ? $currNumber : 0;
        [$currNumber, $nextNumber] = [$nextNumber, $currNumber + $nextNumber];
    }

    return $answer;
}
